#include "RobboLito.h"
#include <string.h>
#include "sorvegliare.h"

void
opzione (char *string)
{
  char *v;
  int valu;
  if (!memcmp (string, "Hash", 28))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  valu = inizializzazione_zobrist (valu);
	  TRASMISSIONE ("Optional Hash %d\n", valu);
	}
    }
}

void
uci ()
{
  TRASMISSIONE ("id name RobboLito vers. %s\n", VERSION);
  TRASMISSIONE ("id author Yakov Petrovich Golyadkin, ");
  TRASMISSIONE ("Igor Igorovich Igoronov, Roberto Pescatore\n");
  TRASMISSIONE ("id copyright Yakov Petrovich Golyadkin (all), "
		"92th plus 93th year from Revolution, PUBLICDOMAIN (workers)\n");
  TRASMISSIONE ("id dedication To Vladimir Ilyich\n");
  TRASMISSIONE
    ("option name Hash (Zobrist) in MegaBytes.");
  TRASMISSIONE (" Note: Only dyadic powers suffice terminally! ");
  TRASMISSIONE ("type spin min 1 max 16384 default 128\n");
  TRASMISSIONE ("uciok\n");
}

void
readyok ()
{
  TRASMISSIONE ("readyok\n");
}

static void
quit ()
{
  exit (0);
}

static void
ingresso_analizi (tipo_posizione *POSIZIONE, char *IN)
{
  if (!strcmp (IN, "quit"))
    quit ();
  if (!strcmp (IN, "stop"))
    cerca_alt (0);
  if (!strcmp (IN, "isready"))
    readyok ();
  if (!strcmp (IN, "ucinewgame"))
    {
      cerca_alt (0);
      partita_nuova (POSIZIONE, VERO);
    }
  if (salto_ok)
    return;
  if (!memcmp (IN, "go", 2))
    {
      cerca_inizializzazione (POSIZIONE, IN);
      if (bordo_legittimo)
	cerca (POSIZIONE);
    }
  if (!memcmp (IN, "position", 8))
    posizionale_inizializzazione (POSIZIONE, IN + 9);
  if (!memcmp (IN, "setoption name", 14))
    opzione (IN + 15);
  if (!strcmp (IN, "uci"))
    uci ();
}

void
ingresso (tipo_posizione *POSIZIONE)
{
  char IN[65536];
  fgets (IN, 65536, stdin);
  IN[strlen (IN) - 1] = 0;
  ingresso_analizi (POSIZIONE, IN);
}
