
#include "RobboLito.h"

tipo_pedone_valu *pedone_zobrist;
static void
pedone_zobrist_inizializzazione ()
{
  posix_memalign ((void *) &pedone_zobrist, 64,
		  elenco_pedone_numero * sizeof (tipo_pedone_valu));
  memset (pedone_zobrist, 0,
	  elenco_pedone_numero * sizeof (tipo_pedone_valu));
}

void
guadagno_reset ()
{
  int i, j;
  for (j = 0; j < 0x10; j++)
    for (i = 0; i < 07777; i++)
      massimo_posizionale_guadagno[j][i] = 0;
}

void
storia_reset ()
{
  int pezzo, qu;
  for (pezzo = 0; pezzo < 16; pezzo++)
    for (qu = A1; qu <= H8; qu++)
      storia_valu[pezzo][qu] = 0x800;
}

static void
gonfalone ()
{
  printf ("RobboLito vers. %s\n", VERSION);
#ifdef HAS_PREFETCH
  printf ("compiled with PREFETCH\n");
#endif
#ifdef HAS_POPCNT
  printf ("compiled with POPCNT\n");
#endif
}

int
main ()
{
  tipo_posizione POSIZIONE[1];
  POSIZIONE->din_iniz = malloc(abisso_massimo * sizeof(tipo_dinamico));
  POSIZIONE->DIN = POSIZIONE->din_iniz;
  gonfalone ();
  pedone_zobrist_inizializzazione ();
  inizializzazione_zobrist (32);
  storia_reset ();
  inizializzazione_cattura ();
  pila_inizializzazione ();
  pedone_inizializzazione ();
  inizializzazione_valore ();
  statico_inizializzazione ();
  partita_nuova (POSIZIONE, VERO);
#ifdef CON_ROBBO_BUILD
  total_iniz ();
#endif
  while (1)
    ingresso (POSIZIONE);
  free (POSIZIONE->din_iniz);
  return 0;
}
